package com.apress.projsp20.ch02.store;

import java.io.*;
import java.util.*;

import javax.servlet.*;
import javax.servlet.http.*;

public class FrontController extends HttpServlet {

	public void init() throws ServletException {

		HashMap products = new HashMap();

		Product p = new Product(1, "Dog", "9.99");
		products.put("1", p);

		p = new Product(2, "Cat", "4.99");
		products.put("2", p);

		p = new Product(3, "Fish", "1.99");
		products.put("3", p);


		//  Store products in the ServletContext
		getServletContext().setAttribute("products", products);

	}

	public void doPost(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {

		// load the action

		System.out.println("request.getPathInfo() = " + request.getPathInfo());
		String name = request.getPathInfo().substring(1);
		System.out.println("name = " + name);
		String viewName = "/error.jsp";
		try {
			name = "com.apress.projsp20.ch02.store." + name;
			System.out.println("name = " + name);
			Class c = getClass().getClassLoader().loadClass(name);
			Action action = (Action) c.newInstance();
			viewName = action.process(request, response);
			System.out.println("viewname = " + viewName);
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		} catch (InstantiationException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
 		}

		RequestDispatcher dispatcher = request.getRequestDispatcher(viewName);
		dispatcher.forward(request, response);


	}

	public void doGet(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {

		doPost(request, response);

	}

}